﻿// CppClient.cpp : 이 파일에는 'main' 함수가 포함됩니다. 거기서 프로그램 실행이 시작되고 종료됩니다.
//

#include <iostream>
#include <atlstr.h>
#include <atlconv.h>
#include <atlbase.h>
#include <atlsafe.h>

#import "CsClassLibrary.tlb" no_namespace named_guids

int main()
{
	HRESULT hr;
	hr = CoInitialize(NULL);
	//hr = CoInitializeEx(nullptr, COINIT_MULTITHREADED);
	IDevice* mp_device;
	bool mb_isSucceeded;
	hr = CoCreateInstance(CLSID_CDevice, NULL, CLSCTX_INPROC_SERVER, DIID_IDevice, reinterpret_cast<void**>(&mp_device));
	if (hr == 0)
	{
		mb_isSucceeded = true;
	}
	else
	{
		mb_isSucceeded = false;
		CoUninitialize();
	}


#pragma region SetFoo
	{
		CComSafeArray<UINT32> _result(8 * 32);
		for (int i = 0; i < _result.GetCount(); i++)
		{
			_result[i] = (UINT32)(i - 100);
		}
		UINT32 retStatus = mp_device->SetFoo(0, 0, _result);
		if (retStatus == 0x00)
		{
			std::cout << "Succeeded to SetTrgOutFieldPacket!\n";
		}
		else
		{
			std::cout << "Failed to SetTrgOutFieldPacket!\n";
		}
		_result.Destroy();
		//return retStatus;
	}
#pragma endregion

#pragma region MyRegion
	{
		CComSafeArray<UINT64> _result(8 * 32, 0);
		for (int i = 0; i < _result.GetCount(); i++)
		{
			_result[i] = (UINT64)1;
		}
		//SAFEARRAY** _ppresult = 0;
		SAFEARRAY* _presult = 0;
		//_ppresult = _result.GetSafeArrayPtr();


		SAFEARRAYBOUND  Bound;
		Bound.lLbound = 0;
		Bound.cElements = 8 * 32;
		//*_ppresult = SafeArrayCreate(VT_UI4, 1, &Bound);
		//_presult = _result.Detach();
		_presult = SafeArrayCreateVector(VT_UI8, 0, 8 * 32);

		//IRecordInfoPtr pRecInfo = nullptr;
		//*_ppresult = SafeArrayCreateEx(VT_ARRAY, 1, &Bound, pRecInfo);
		//HRESULT hr = SafeArrayLock(*_ppresult);

		//UINT32* prgn = 0;
		//hr = SafeArrayAccessData(*_ppresult, reinterpret_cast<void**>(&prgn));


		unsigned long retStatus;
		_presult = mp_device->GetFoo(0, 0, &retStatus);

		if (retStatus == 0x00)
		{
			std::cout << "Succeeded to GetTrgOutFieldPacket!\n";
		}
		else
		{
			std::cout << "Failed to GetTrgOutFieldPacket!\n";
		}
		//SafeArrayUnaccessData(_result);
		//SafeArrayDestroy(*_ppresult);
		SafeArrayDestroy(_presult);
	}
#pragma endregion

	

    std::cout << "Hello World!\n";
}

// 프로그램 실행: <Ctrl+F5> 또는 [디버그] > [디버깅하지 않고 시작] 메뉴
// 프로그램 디버그: <F5> 키 또는 [디버그] > [디버깅 시작] 메뉴

// 시작을 위한 팁: 
//   1. [솔루션 탐색기] 창을 사용하여 파일을 추가/관리합니다.
//   2. [팀 탐색기] 창을 사용하여 소스 제어에 연결합니다.
//   3. [출력] 창을 사용하여 빌드 출력 및 기타 메시지를 확인합니다.
//   4. [오류 목록] 창을 사용하여 오류를 봅니다.
//   5. [프로젝트] > [새 항목 추가]로 이동하여 새 코드 파일을 만들거나, [프로젝트] > [기존 항목 추가]로 이동하여 기존 코드 파일을 프로젝트에 추가합니다.
//   6. 나중에 이 프로젝트를 다시 열려면 [파일] > [열기] > [프로젝트]로 이동하고 .sln 파일을 선택합니다.
